use conjure_object::serde::{ser, de};
use conjure_object::serde::ser::SerializeMap as SerializeMap_;
use conjure_object::private::{UnionField_, UnionTypeField_};
use std::fmt;
#[derive(Debug, Clone, PartialEq, Eq, PartialOrd, Ord, Hash)]
pub enum AggregationType {
    Max(super::Max),
    Min(super::Min),
    Mean(super::Mean),
    StandardDeviation(super::StandardDeviation),
    Count(super::Count),
    RootMeanSquare(super::RootMeanSquare),
    /// An unknown variant.
    Unknown(Unknown),
}
impl ser::Serialize for AggregationType {
    fn serialize<S>(&self, s: S) -> Result<S::Ok, S::Error>
    where
        S: ser::Serializer,
    {
        let mut map = s.serialize_map(Some(2))?;
        match self {
            AggregationType::Max(value) => {
                map.serialize_entry(&"type", &"max")?;
                map.serialize_entry(&"max", value)?;
            }
            AggregationType::Min(value) => {
                map.serialize_entry(&"type", &"min")?;
                map.serialize_entry(&"min", value)?;
            }
            AggregationType::Mean(value) => {
                map.serialize_entry(&"type", &"mean")?;
                map.serialize_entry(&"mean", value)?;
            }
            AggregationType::StandardDeviation(value) => {
                map.serialize_entry(&"type", &"standardDeviation")?;
                map.serialize_entry(&"standardDeviation", value)?;
            }
            AggregationType::Count(value) => {
                map.serialize_entry(&"type", &"count")?;
                map.serialize_entry(&"count", value)?;
            }
            AggregationType::RootMeanSquare(value) => {
                map.serialize_entry(&"type", &"rootMeanSquare")?;
                map.serialize_entry(&"rootMeanSquare", value)?;
            }
            AggregationType::Unknown(value) => {
                map.serialize_entry(&"type", &value.type_)?;
                map.serialize_entry(&value.type_, &value.value)?;
            }
        }
        map.end()
    }
}
impl<'de> de::Deserialize<'de> for AggregationType {
    fn deserialize<D>(d: D) -> Result<AggregationType, D::Error>
    where
        D: de::Deserializer<'de>,
    {
        d.deserialize_map(Visitor_)
    }
}
struct Visitor_;
impl<'de> de::Visitor<'de> for Visitor_ {
    type Value = AggregationType;
    fn expecting(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt.write_str("union AggregationType")
    }
    fn visit_map<A>(self, mut map: A) -> Result<AggregationType, A::Error>
    where
        A: de::MapAccess<'de>,
    {
        let v = match map.next_key::<UnionField_<Variant_>>()? {
            Some(UnionField_::Type) => {
                let variant = map.next_value()?;
                let key = map.next_key()?;
                match (variant, key) {
                    (Variant_::Max, Some(Variant_::Max)) => {
                        let value = map.next_value()?;
                        AggregationType::Max(value)
                    }
                    (Variant_::Min, Some(Variant_::Min)) => {
                        let value = map.next_value()?;
                        AggregationType::Min(value)
                    }
                    (Variant_::Mean, Some(Variant_::Mean)) => {
                        let value = map.next_value()?;
                        AggregationType::Mean(value)
                    }
                    (Variant_::StandardDeviation, Some(Variant_::StandardDeviation)) => {
                        let value = map.next_value()?;
                        AggregationType::StandardDeviation(value)
                    }
                    (Variant_::Count, Some(Variant_::Count)) => {
                        let value = map.next_value()?;
                        AggregationType::Count(value)
                    }
                    (Variant_::RootMeanSquare, Some(Variant_::RootMeanSquare)) => {
                        let value = map.next_value()?;
                        AggregationType::RootMeanSquare(value)
                    }
                    (Variant_::Unknown(type_), Some(Variant_::Unknown(b))) => {
                        if type_ == b {
                            let value = map.next_value()?;
                            AggregationType::Unknown(Unknown { type_, value })
                        } else {
                            return Err(
                                de::Error::invalid_value(de::Unexpected::Str(&type_), &&*b),
                            )
                        }
                    }
                    (variant, Some(key)) => {
                        return Err(
                            de::Error::invalid_value(
                                de::Unexpected::Str(key.as_str()),
                                &variant.as_str(),
                            ),
                        );
                    }
                    (variant, None) => {
                        return Err(de::Error::missing_field(variant.as_str()));
                    }
                }
            }
            Some(UnionField_::Value(variant)) => {
                let value = match &variant {
                    Variant_::Max => {
                        let value = map.next_value()?;
                        AggregationType::Max(value)
                    }
                    Variant_::Min => {
                        let value = map.next_value()?;
                        AggregationType::Min(value)
                    }
                    Variant_::Mean => {
                        let value = map.next_value()?;
                        AggregationType::Mean(value)
                    }
                    Variant_::StandardDeviation => {
                        let value = map.next_value()?;
                        AggregationType::StandardDeviation(value)
                    }
                    Variant_::Count => {
                        let value = map.next_value()?;
                        AggregationType::Count(value)
                    }
                    Variant_::RootMeanSquare => {
                        let value = map.next_value()?;
                        AggregationType::RootMeanSquare(value)
                    }
                    Variant_::Unknown(type_) => {
                        let value = map.next_value()?;
                        AggregationType::Unknown(Unknown {
                            type_: type_.clone(),
                            value,
                        })
                    }
                };
                if map.next_key::<UnionTypeField_>()?.is_none() {
                    return Err(de::Error::missing_field("type"));
                }
                let type_variant = map.next_value::<Variant_>()?;
                if variant != type_variant {
                    return Err(
                        de::Error::invalid_value(
                            de::Unexpected::Str(type_variant.as_str()),
                            &variant.as_str(),
                        ),
                    );
                }
                value
            }
            None => return Err(de::Error::missing_field("type")),
        };
        if map.next_key::<UnionField_<Variant_>>()?.is_some() {
            return Err(de::Error::invalid_length(3, &"type and value fields"));
        }
        Ok(v)
    }
}
#[derive(PartialEq)]
enum Variant_ {
    Max,
    Min,
    Mean,
    StandardDeviation,
    Count,
    RootMeanSquare,
    Unknown(Box<str>),
}
impl Variant_ {
    fn as_str(&self) -> &'static str {
        match *self {
            Variant_::Max => "max",
            Variant_::Min => "min",
            Variant_::Mean => "mean",
            Variant_::StandardDeviation => "standardDeviation",
            Variant_::Count => "count",
            Variant_::RootMeanSquare => "rootMeanSquare",
            Variant_::Unknown(_) => "unknown variant",
        }
    }
}
impl<'de> de::Deserialize<'de> for Variant_ {
    fn deserialize<D>(d: D) -> Result<Variant_, D::Error>
    where
        D: de::Deserializer<'de>,
    {
        d.deserialize_str(VariantVisitor_)
    }
}
struct VariantVisitor_;
impl<'de> de::Visitor<'de> for VariantVisitor_ {
    type Value = Variant_;
    fn expecting(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt.write_str("string")
    }
    fn visit_str<E>(self, value: &str) -> Result<Variant_, E>
    where
        E: de::Error,
    {
        let v = match value {
            "max" => Variant_::Max,
            "min" => Variant_::Min,
            "mean" => Variant_::Mean,
            "standardDeviation" => Variant_::StandardDeviation,
            "count" => Variant_::Count,
            "rootMeanSquare" => Variant_::RootMeanSquare,
            value => Variant_::Unknown(value.to_string().into_boxed_str()),
        };
        Ok(v)
    }
}
///An unknown variant of the AggregationType union.
#[derive(Debug, Clone, PartialEq, Eq, PartialOrd, Ord, Hash)]
pub struct Unknown {
    type_: Box<str>,
    value: conjure_object::Any,
}
impl Unknown {
    /// Returns the unknown variant's type name.
    #[inline]
    pub fn type_(&self) -> &str {
        &self.type_
    }
}
